/** @type {import('jest').Config} */
const config = {
    verbose: false,
    testTimeout: 5000,
    reporters: [
        'default',
        [
            'jest-junit',
            { outputDirectory: 'reports', outputName: 'report.xml' },
        ],
    ],
    collectCoverage: true,
    collectCoverageFrom: [
        'src/**/*.{js,jsx}',
        '!**/node_modules/**',
        '!**/build/**',
    ],
    coverageReporters: ['clover', 'lcov', ['text', { skipFull: true }]],
    coverageDirectory: 'reports',
    showSeed: true,
    slowTestThreshold: 5,
};

module.exports = config;
