import express from 'express';
import passport from 'passport';
import { updateMyProfile } from '../../middleware/Users';

// eslint-disable-next-line new-cap
const router = express.Router();

router
    .route('/')
    .get(passport.authenticate('jwt'), (req, res) => {
        res.status(200).json(req.user);
    })
    .patch(passport.authenticate('jwt'), async (req, res, next) => {
        try {
            const data = await updateMyProfile(req);

            res.status(200).json(data);
        } catch (err) {
            next(err);
        }
    });

export default router;
