import express from 'express';
import { createUser } from '../../middleware/Users';

// eslint-disable-next-line new-cap
const router = express.Router();

router.route('/').post(async (req, res, next) => {
    try {
        const data = await createUser(req);

        res.status(201).json(data);
    } catch (err) {
        if (err.name === 'SequelizeUniqueConstraintError') {
            err.status = 409;
        }
        next(err);
    }
});

export default router;
